#include "redactionwidget.h"
#include <QSqlQuery>

RedactionWidget::RedactionWidget(QWidget *parent) : QWidget(parent)
{

     this->hide();
     testOutput = new QTextBrowser();
     this->hide();
     mainLayout = new QGridLayout(this);
     testsList = new QListView();
     questionList = new QListView();
     change = new QPushButton("Изменить", this);
     add = new QPushButton("Добавить", this);
     del = new QPushButton("Удалить", this);
     chgWidget = new ChangeWidget();
     qe = new QuestionEntity();
     exit = new QPushButton("Назад");

     testsList->setEditTriggers(QListView::NoEditTriggers);
     questionList->setEditTriggers(QListView::NoEditTriggers);
     mainLayout->addWidget(testsList,0,0);
     mainLayout->addWidget(questionList,0,1);
     mainLayout->addWidget(testOutput,1,0,1,2);
     mainLayout->addWidget(change, 2,0);
     mainLayout->addWidget(add, 2,1);
     mainLayout->addWidget(del, 3,1);
     mainLayout->addWidget(exit,3,0);

     QStringListModel* strListModel = new QStringListModel(testsList);
     QStringList *strList = new QStringList();
     QSqlQueryModel *queryModel = new QSqlQueryModel(this);
     queryModel->setQuery("SELECT name FROM tests",db);
     for(int i = 0; i < queryModel->rowCount(); i++ )
     {
         strList->push_back(queryModel->index(i,0).data().toString());
     }
     strListModel->setStringList(*strList);
     testsList->setModel(strListModel);

     connect(testsList, SIGNAL(doubleClicked(QModelIndex)),this, SLOT(onLVdoubleClicked(QModelIndex)));
     connect(questionList, SIGNAL(doubleClicked(QModelIndex)), this, SLOT(onLV2doubleClicked(QModelIndex)));
     connect(questionList, SIGNAL(doubleClicked(QModelIndex)), this, SLOT(showTest(QModelIndex)));

     connect(add, SIGNAL(clicked()), this, SLOT(sendDB(db)));
     connect(this, SIGNAL(sendDataBase(const QSqlDatabase &)), chgWidget, SLOT(recieveDataBase(const QSqlDatabase &)));
     connect(change, SIGNAL(clicked()), this, SLOT(sendDB(db)) );

     connect(add, SIGNAL(clicked()), this, SLOT(sendQE()));
    // connect(this, SIGNAL(sendQuestion(const QuestionEntity &)), chgWidget, SLOT(receiveQuestion(const QuestionEntity &)));
     connect(change, SIGNAL(clicked()), this, SLOT(sendQE()) );


      connect(add, SIGNAL(clicked()), this, SLOT(sendAddType()));
      connect(change, SIGNAL(clicked()), this, SLOT(sendChangeType()));
      connect(this, SIGNAL(sendT(bool)), chgWidget, SLOT(paintWidget(bool)));

      connect(del, SIGNAL(clicked()), this, SLOT(deleteQuestion()));





}

void RedactionWidget::receiveDataBase(const QSqlDatabase &p_db)
{
    db = p_db;
}

void RedactionWidget::onLVdoubleClicked(const QModelIndex &inx)
{
    QSqlQueryModel *model = new QSqlQueryModel();
    model->setQuery(QSqlQuery("SELECT question FROM test_questions WHERE test_id = " + QString::number(inx.row()+1), db));
    QStringList *strList = new QStringList();
    QStringListModel *strListModel = new QStringListModel(questionList);
    for(int i = 0; i < model->rowCount(); i++ )
    {
        strList->push_back(model->index(i,0).data().toString());
    }
    strListModel->setStringList(*strList);
    questionList->setModel(strListModel);

}

void RedactionWidget::onLV2doubleClicked(const QModelIndex &inx)
{
    QString testString;
    QString questionName = inx.data().toString();
    qDebug() << questionName;
    QSqlQuery query("SELECT * FROM test_questions WHERE question = '" + questionName + "';",db);
    QSqlQueryModel *model = new QSqlQueryModel();
    model->setQuery(query);
    int id = model->index(0, 0).data().toInt();
    QString question = model->index(0, 1).data().toString();
    QStringList variantsList = model->index(0, 2).data().toString().split("%");
    QStringList answersList = model->index(0, 3).data().toString().split(" ");
    QSet<QString> answers(answersList.begin(), answersList.end());
    qe->setAnswers(answers);
    qe->setQuestion(question);
    qe->setId(id);
    qe->setVariants(variantsList);
    testString+= "\n" + qe->getQuestion() + "\n";

    for(auto& el:qe->getVariants()){
        testString+= + " " + el +"\n";
    }
     testString += "Правильный ответ: ";
    for(auto& el: qe->getAnswers()){
        testString += el + " ";
    }
    testString += "\n";
    testOutput->setText(testString);


}

void RedactionWidget::sendDB(const QSqlDatabase &p_db)
{
    emit(sendDataBase(p_db));
}

void RedactionWidget::sendQE()
{
    //emit(sendQuestion(qe));
    QSqlQueryModel *model = new QSqlQueryModel(this);
    model->setQuery(QSqlQuery("SELECT test_id from test_questions WHERE question = '" +qe-> getQuestion() +"';", db));
    int id = model->index(0,0).data().toInt();
    chgWidget->setQuestion(*qe,id);
}

void RedactionWidget::sendAddType()
{
    emit(sendT(false));
}

void RedactionWidget::sendChangeType()
{
    emit(sendT(true));
}
void RedactionWidget::deleteQuestion()
{
    QSqlQueryModel *model = new QSqlQueryModel(this);
    model->setQuery(QSqlQuery("DELETE from test_questions WHERE question = '"+qe->getQuestion()+"';", db));

}




