#ifndef REDACTIONWIDGET_H
#define REDACTIONWIDGET_H

#include <QWidget>
#include <QSqlDatabase>
#include <QListWidget>
#include <QHBoxLayout>
#include <QStringListModel>
#include <QSqlQueryModel>
#include <QTextBrowser>
#include <QDebug>
#include <QGridLayout>
#include <QPushButton>
#include "question.h"
#include "changewidget.h"

class RedactionWidget : public QWidget
{
    Q_OBJECT
public:
    explicit RedactionWidget(QWidget *parent = nullptr);
    QPushButton* exit;

signals:
    void sendDataBase(const QSqlDatabase &p_db);
    void sendQuestion(const QuestionEntity &qe);
    void sendT(bool type);

public slots:
    void receiveDataBase(const QSqlDatabase & p_db);
    void onLVdoubleClicked(const QModelIndex &inx);
    void onLV2doubleClicked(const QModelIndex &inx);
    void sendDB(const QSqlDatabase &p_db);
    void sendQE();
    void sendAddType();
    void sendChangeType();
    void deleteQuestion();
private:
    QSqlDatabase db;
    QListView *testsList;
    QListView *questionList;
    QGridLayout *mainLayout;
    QTextBrowser *testOutput;
    QPushButton *change;
    QPushButton *add;
    QPushButton *del;
    ChangeWidget *chgWidget;
    QuestionEntity *qe;









};

#endif // REDACTIONWIDGET_H
